//----------------------------------------------------------------
//	vector.cpp
//		VectorNX̒`
//----------------------------------------------------------------

#include	"vector2.h"


//RXgN^
Vector2::Vector2(){
	Vector	v;
	for(	int	i=0;	i<VLEN;	i++){
		element[i]	=	v;
	}
}
Vector2::Vector2(	Vector	v	){
	for(	int	i=0;	i<VLEN;	i++){
		element[i]	=	v;
	}
}
Vector2::Vector2(	Vector	x,	Vector	y,	Vector	z){
	Vector	v;
	element[0]	=	x;
	element[1]	=	y;
	if(	VLEN	>=3	){
		element[2]	=	z;
	}
	for(	int	i=3;	i<VLEN;	i++){
		element[i]	=	v;
	}
}

//fBXgN^
Vector2::~Vector2(){
}

//Zq̒`
ostream&	operator<<(	ostream&	s,	Vector2&	v1){
	for(	int	i=0;	i<VLEN;	i++){
		s	<<	v1[i]	<<	"\n";
	}
}
istream&	operator>>(	istream& s,	Vector2&	v1){
	cout	<<	"\n";
	for(	int	i=0;	i<VLEN;	i++){
		cout	<<	"	";
		s	>>	v1[i];
	}
}
Vector2		operator	+		(	Vector2&	v1,	Vector2&	v2	){
	Vector2	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	+	v2[i];
	}
	return	v;
}
Vector2		operator	-		(	Vector2&	v1	){
	Vector2	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	-v1[i];
	}
	return	v;
}
Vector2		operator	-		(	Vector2&	v1,	Vector2&	v2	){
	Vector2	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	-	v2[i];
	}
	return	v;
}
Vector2		operator	*		(	Vector2&	v1,	double	d	){
	Vector2	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	*	d;
	}
	return	v;
}
Vector2		operator	*		(	double	d,	Vector2&	v1	){
	Vector2	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	*	d;
	}
	return	v;
}
Vector2		operator	/		(	Vector2&	v1,	double	d	){
	Vector2	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	/	d;
	}
	return	v;
}

void			operator	+=	(	Vector2&	v1,	Vector2&	v2	){
	v1	=	v1+v2;
}
void			operator	-=	(	Vector2&	v1,	Vector2&	v2	){
	v1	=	v1-v2;
}
void			operator	*=	(	Vector2&	v1,	double		d	){
	v1	=	v1*d;
}
void			operator	/=	(	Vector2&	v1,	double		d	){
	v1	=	v1/d;
}
int				operator	==	(	Vector2&	v1,	Vector2&	v2	){
	double	d=1;
	for(	int	i=0;	i<VLEN;	i++){
		d	*=	(	v1[i]	==	v2[i]	);
	}
	return	d;
}


Vector		operator	*		(	Vector&		v1,	Vector2&	v2	){
	Vector	v;
		for(	int	j=0;	j<VLEN;	j++){
			for(	int	k=0;	k<VLEN;	k++){
				v[j]	+=	(v1[k]	*	v2[k][j]);
			}
		}
	return	v;
}
Vector		operator	*		(	Vector2&	v1,	Vector&		v2	){
	Vector	v;
	for(	int	i=0;	i<VLEN;	i++){
		for(	int	k=0;	k<VLEN;	k++){
				v[i]	+=	(v1[i][k]	*	v2[k]);
		}
	}
	return	v;
}

Vector2		operator	*		(	Vector2&	v1,	Vector2&	v2	){
	Vector2	v;
	for(	int	i=0;	i<VLEN;	i++){
		for(	int	j=0;	j<VLEN;	j++){
			for(	int	k=0;	k<VLEN;	k++){
				v[i][j]	+=	(v1[i][k]	*	v2[k][j]);
			}
		}
	}
	return	v;
}
